﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Timers;

namespace ApplicationLogic
{
    public class DoTheJob
    {
        public event EventHandler<ProgressInfo> Progress;
        public event EventHandler Done;
        public event EventHandler Aborted;

        public int Count
        {
            get { return count; }
            set { count = value; }
        }

        private int done = 0;
        private int count = 100;
        private Timer t = new Timer(100);

        private void someJob(object sender, EventArgs e)
        {
            done++;
            
            EventHandler<ProgressInfo> temp = Progress;
            
            if (temp != null)
                temp(this, new ProgressInfo(count, done));

            if (done >= count)
            {
                stop(Done);
            }
        }

        public void start()
        {
            t.Elapsed += someJob;
            t.Start();
        }

        public void stop()
        {
            stop(Aborted);
        }

        private void stop(EventHandler stopEvent)
        {
            t.Elapsed -= someJob;
            t.Stop();
            done = 0;
            if (stopEvent != null)
                stopEvent(this, EventArgs.Empty);

        }

    }
}
