﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using ApplicationLogic;


namespace WindowsFormsEvents
{
    public partial class Form1 : Form
    {
        private DoTheJob job;

        public Form1()
        {
            InitializeComponent();

            job = new DoTheJob();

            job.Count = 50;
            progressBar.Maximum = job.Count;

            job.Progress    += progressBarIncrease;
            job.Progress    += stateLabelChange;

            job.Aborted     += aborted;
            job.Aborted     += finish;

            job.Done += finish;
        }

        private void buttonStart_Click(object sender, EventArgs e)
        {
            job.start();

            buttonStart.Enabled = false;
            buttonStop.Enabled = true;
        }

        private void buttonStop_Click(object sender, EventArgs e)
        {
            job.stop();
        }

        private void progressBarIncrease(object sender, ProgressInfo e)
        {
            if (this.InvokeRequired)
                this.Invoke(new EventHandler<ProgressInfo>(progressBarIncrease), new object[] { sender, e });
            else
                progressBar.Value = e.Done;
        }

        private void stateLabelChange(object sender, ProgressInfo e)
        {
            if (this.InvokeRequired)
                this.Invoke(new EventHandler<ProgressInfo>(stateLabelChange), new object[] { sender, e });
            else
            labelStan.Text = "Done: " + e.Done + "/" + e.Count;
        }

        private void finish(object sender, EventArgs e)
        {
            if (this.InvokeRequired)
                this.Invoke(new EventHandler<EventArgs>(finish), new object[] { sender, e });
            else
            {
                buttonStart.Enabled = true;
                buttonStop.Enabled = false;
                progressBar.Value = 0;
                labelStan.Text = "Nic nie robię";
            }
        }

        private void aborted(object sender, EventArgs e)
        {
            MessageBox.Show("Aborted");
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.Text = textBox1.Text;
        }

    }
}